

/***********************************
 * TODO:
 * add logic to print human readable tick sizes, i.e.
 * 10 kb instead of 10,000 bp
 */


Vue.component( "axis", {
  template:
    `
    <svg :x="x" :y="y" :width="width" :height="height" ><!--:viewBox="xOffset +' '+ vOffset +' '+ width + xOffset +' '+ vOffset + height"><!-- -->
        <line x1="0" :y1="2*vOffset" :x2="width" :y2="2*vOffset" style="stroke:rgb(0,0,0);stroke-width:1" />

        <line x1="0" :y1="2*vOffset" x2="0" :y2="vOffset" stroke="black" />
        <line :x1="width" :y1="2*vOffset" :x2="width" :y2="vOffset" stroke="black" />

        <line v-for="tick in ticks" :x1="tick.panelPos" :y1="2*vOffset" :x2="tick.panelPos" :y2="vOffset+2" stroke="black"/>
        <text v-for="tick in ticks" :style="'font: '+vOffset+'px roboto;'"class="small" :x="tick.panelPos" :y="vOffset" text-anchor="middle" fill="black">{{ tick.genomePos }}</text>
    </svg>
    <!-- -->
    `,
  props: {
    x: Number,
    y: Number,
    start: Number,
    stop: Number,
    genomeSize: Number,
    width: Number,
    height: Number,
    xOffset: Number,
    vOffset: Number,
  },
  methods: {
      genomeToPixel( pos ) {
          return (this.width*(pos-this.start))/(this.length) 
      }
  },
  computed:{
    power(){
      return Math.floor(Math.log10(this.length))
    },
    length(){
      return (this.stop - this.start)
    },
    genomeSectionSize(){
      return (this.start > this.stop) ? (this.genomeSize-this.start + this.end) : Math.abs(this.stop-this.start) // genome section in bp
    },
    tickSize(){ 
      return Math.pow(10, this.power-1)
      //return Math.pow( 10, Math.round( Math.log10( this.genomeSectionSize / this.noTicks ) ) ) // axis tick size in log 10 bp
    },
    noTicks(){
      return Math.floor(this.length/this.tickSize)+2
    },
    ticks(){
      const firstTickPos = Math.round(this.start/this.tickSize)*this.tickSize//Math.pow( 10, Math.floor( Math.log10( this.start ) ) )
      let ticks = new Array(this.noTicks)
      for(i=0; i<ticks.length; i+=1){
        ticks[i] = {}
        ticks[i].genomePos = firstTickPos + i*this.tickSize
        ticks[i].panelPos = this.genomeToPixel(ticks[i].genomePos)
      }
      return ticks
    },
  },
  data: function(){
    return {
        //noTicks: 10
        //ticks: []
    }
  }
} )

