Vue.component("feature",{
  template: 
    `
    <svg :height="svgHeight" :width="svgWidth" :x="svgX" :y="svgY">
        <polygon :points="arrow_coordinates" :style=featureStyle @click="clickEvent" />
    </svg>
    `,
  props: ['svgWidth', 'svgHeight', 'svgX', 'svgY', 'color', 'borderColor', 'featureId'],
  computed: {
    featureStyle () {
      return {
        'fill': this.color,
        'stroke': this.borderColor,
        'stroke-width': 1
      }
    },
    arrow_coordinates () {
      let points = [
        '0, ' + this.svgHeight * 0.25,
        '0, ' + this.svgHeight * 0.75,
        this.svgWidth * 0.7 + ', ' + this.svgHeight * 0.75,
        this.svgWidth * 0.7 + ', ' + this.svgHeight * 0.95,
        this.svgWidth + ', ' + this.svgHeight * 0.5,
        this.svgWidth * 0.7 + ', ' + this.svgHeight * 0.05,
        this.svgWidth * 0.7 + ', ' + this.svgHeight * 0.25
      ]
      return points.join(' ')
    },
  },
  methods: {
    clickEvent (evt) {
      this.$emit('click', this.featureId)
    }
  },
  data: function(){
    return {
      todo: "todo"
    }
  }
})

